// This Source Code Form is subject to the terms of the Mozilla Public
// License, v. 2.0. If a copy of the MPL was not distributed with this
// file, You can obtain one at https://mozilla.org/MPL/2.0/.
nz-spin([nzSpinning]="workflowLoading$ | async", nzTip="Loading workflow...")
  div(*ngIf="(workflow$ | async) as workflow", nz-row)
    aside(nz-col, nzSpan="9")
      a(routerLink="/dashboard", nz-button, [nzGhost]="true", nzType="default", nzSize="small")
        i(nz-icon, nzType="arrow-left", nzTheme="outline")
        | Dashboard
      #ryax-workflow-title
        div#title
          h1 {{ workflow.name }}
          ryax-deployment-tag([status]="workflow.deploymentStatus")
        div#message(*ngIf="(workflowStatus$ | async) === 'Error'")
          p
            span Deployment Error:&nbsp;
            | {{ workflow.deploymentError }}

      nav
        ul#ryax-panels
          li
            a(routerLink="overview", routerLinkActive="ryax-active") Overview
          li
            a(routerLink="runs", routerLinkActive="ryax-active") Runs
        #ryax-wf-buttons
          ng-container(*ngIf="(workflowStatus$ | async) === 'Valid'")
            ryax-has-roles([roles]="studioRoles")
              a(nz-button, nzGhost, nzType="primary", [routerLink]="'/studio/' + workflow.id") Edit
            button(, nz-button, nzType="primary", (click)="deploy()") Deploy
          ng-container(*ngIf="(workflowStatus$ | async) === 'Invalid'")
            ryax-has-roles([roles]="studioRoles")
              a(nz-button, nzType="primary", [routerLink]="'/studio/' + workflow.id") Edit
          ng-container(*ngIf="(workflowStatus$ | async) === 'Deploying'")
            button(nz-button, nzType="primary", nzGhost, (click)="stop(false)") Stop
            button(nz-button, nzType="primary", disabled) Deploying...
          ng-container(*ngIf="(workflowStatus$ | async) === 'Deployed'")
            button(nz-button, nzType="primary", nzGhost, (click)="stop(true)", nz-tooltip="Let all remaining runs finish") Stop
            button(nz-button, nzType="primary", nzGhost, nzDanger, (click)="stop(false)", nz-tooltip="Cancel all remaining runs") Force Stop
            a(*ngIf="workflow.hasForm", nz-button, nzType="primary", [routerLink]="'/runs/form/' + workflow.id") New Run
          ng-container(*ngIf="(workflowStatus$ | async) === 'Error'")
            ryax-has-roles([roles]="studioRoles")
              a(nz-button, nzType="primary", [routerLink]="'/studio/' + workflow.id") Edit
            button(nz-button, nzType="primary", nzGhost, (click)="deploy()") Retry Deploy
          button(nz-button, nz-dropdown, [nzDropdownMenu]="extraActions")
            i(nz-icon, nzType="more", nzTheme="outline")
          nz-dropdown-menu(#extraActions="nzDropdownMenu")
            ul(nz-menu)
              li(nz-menu-item, (click)="export()") Export
              li(nz-menu-item, (click)="duplicate()") Duplicate
              li(*ngIf="['Valid', 'Invalid', 'Error'].includes((workflowStatus$ | async)!)",
                nz-menu-item, nzDanger, (click)="delete()") Delete

      nz-card(*ngIf="workflow.description")
        h2 Description
        p {{ workflow.description }}

      nz-card
        div
          h2 Runs
          p {{ workflowRunsLength$ | async }} runs
          a#ryax-refresh((click)="refreshRuns()")
            i(nz-icon, nzType="redo", nzTheme="outline")
          a(routerLink="runs") See all

      nz-card#ryax-results
        h2 Results
        ng-container(*ngIf="(resultsConfig$ | async)?.length; else noResult")
          p(*ngFor="let result of (resultsConfig$ | async)")
            span {{ result.key }}:
            | {{ result.description }}
        ng-template(#noResult)
          p This workflow returns no result

    section(nz-col, nzSpan="14", nzOffset="1")
      router-outlet
